<template>
  <div class="row">
    <div v-for="item in formData" :key="item.key" class="col-12">
      <b-form-item
        v-if="!checkHidden(item)"
        :label="item.meta.displayName || item.key"
      >
        <b-select
          v-if="item.meta.inputType === 'select'"
          v-model="item.value"
          :multiple="item.meta.multiple"
          @change="handleChange"
        >
          <b-option
            v-for="option in item.meta.options"
            :key="option.key"
            :value="option.key"
            :label="option.label"
          >
          </b-option>
        </b-select>

        <b-numeric-input
          v-else-if="item.meta.inputType === 'number'"
          v-model="item.value"
          type="number"
          @change="handleChange"
        />

        <b-date-picker
          v-else-if="item.meta.inputType === 'date'"
          v-model="item.value"
          @change="handleChange"
        />

        <b-radio-group
          v-else-if="item.meta.inputType === 'radio'"
          v-model="item.value"
          @change="handleChange"
        >
          <b-radio-button
            v-for="option in item.meta.options"
            :key="option.key"
            :label="option.label"
            >{{ option }}
          </b-radio-button>
        </b-radio-group>

        <div
          v-else-if="item.meta.inputType === 'checkbox'"
          style="display: flex; justify-content: center"
        >
          <b-checkbox v-model="item.value" @change="handleChange"></b-checkbox>
        </div>

        <b-input v-else v-model="item.value" @change="handleChange"></b-input>
      </b-form-item>
    </div>
  </div>
</template>

<script>
import { cloneDeep } from 'lodash'

export default {
  name: 'CamundaForm',
  props: {
    value: {
      type: Array,
      default() {
        return []
      },
    },
  },
  data() {
    return {
      formData: [],
    }
  },
  created() {
    this.formData = cloneDeep(this.value)
  },
  methods: {
    checkHidden(item) {
      if (!item.meta.hidden) return false
      const value = this.formData.find((x) => x.key === item.meta.hidden.field)
        ?.value
      // eslint-disable-next-line eqeqeq
      return value == item.meta.hidden.value
    },
    handleChange() {
      this.$emit('input', this.formData)
    },
  },
}
</script>
